//==============================================================================
//						Communication & Command Լ
//==============================================================================

#include <mega128.h>
#include <string.h>
#include "Main.h"
#include "Macro.h"
#include "Comm.h"
#include "p_ex1.h"

//------------------------------------------------------------------------------
// ø Ʈ  ڸ ϱ  Լ
//------------------------------------------------------------------------------
void sciTx0Data(BYTE td)
{
	while(!(UCSR0A&(1<<UDRE))); 	//   Ϸɶ 
	UDR0=td;
}

void sciTx1Data(BYTE td)
{
	while(!(UCSR1A&(1<<UDRE))); 	//   Ϸɶ 
	UDR1=td;
}


//------------------------------------------------------------------------------
// ø Ʈ  ڸ  ϱ  Լ
//------------------------------------------------------------------------------
BYTE sciRx0Ready(void)
{
	WORD	startT;
	startT = gMSEC;
	while(!(UCSR0A&(1<<RXC)) ){ 	//  ڰ ŵɶ 
        if(gMSEC<startT){
			// Ÿ ƿ  Ż
            if((1000 - startT + gMSEC)>RX_T_OUT) break;
        }
		else if((gMSEC-startT)>RX_T_OUT) break;
	}
	return UDR0;
}

BYTE sciRx1Ready(void)
{
	WORD	startT;
	startT = gMSEC;
	while(!(UCSR1A&(1<<RXC)) ){ 	//  ڰ ŵɶ 
        if(gMSEC<startT){
			// Ÿ ƿ  Ż
            if((1000 - startT + gMSEC)>RX_T_OUT) break;
        }
		else if((gMSEC-startT)>RX_T_OUT) break;
	}
	return UDR1;
}


//------------------------------------------------------------------------------
// wCK Ķ͸   
// Input	: Data1, Data2, Data3, Data4
// Output	: None
//------------------------------------------------------------------------------
void SendSetCmd(BYTE ID, BYTE Data1, BYTE Data2, BYTE Data3)
{
	BYTE CheckSum; 
	ID=(BYTE)(7<<5)|ID; 
	CheckSum = (ID^Data1^Data2^Data3)&0x7f;

	gTx0Buf[gTx0Cnt]=HEADER;
	gTx0Cnt++;			// ۽ Ʈ 

	gTx0Buf[gTx0Cnt]=ID;
	gTx0Cnt++;			// ۽ Ʈ 

	gTx0Buf[gTx0Cnt]=Data1;
	gTx0Cnt++;			// ۽ Ʈ 

	gTx0Buf[gTx0Cnt]=Data2;
	gTx0Cnt++;			// ۽ Ʈ 

	gTx0Buf[gTx0Cnt]=Data3;
	gTx0Cnt++;			// ۽ Ʈ 

	gTx0Buf[gTx0Cnt]=CheckSum;
	gTx0Cnt++;			// ۽ Ʈ 
}


//------------------------------------------------------------------------------
// ȭ ġ (Synchronized Position Send Command)  Լ
//------------------------------------------------------------------------------
void SyncPosSend(void) 
{
	int lwtmp;
	BYTE CheckSum; 
	BYTE i, tmp, Data;

	Data = (Scene.wCK[0].Torq<<5) | 31;

	gTx0Buf[gTx0Cnt]=HEADER;
	gTx0Cnt++;			// ۽ Ʈ 

	gTx0Buf[gTx0Cnt]=Data;
	gTx0Cnt++;			// ۽ Ʈ 

	gTx0Buf[gTx0Cnt]=16;
	gTx0Cnt++;			// ۽ Ʈ 

	CheckSum = 0;
	for(i=0;i<MAX_wCK;i++){	//  wCK  غ
		if(Scene.wCK[i].Exist){	// ϴ ID غ
			lwtmp = (int)Scene.wCK[i].SPos + (int)((float)gFrameIdx*gUnitD[i]);
			if(lwtmp>254)		lwtmp = 254;
			else if(lwtmp<1)	lwtmp = 1;
			tmp = (BYTE)lwtmp;
			gTx0Buf[gTx0Cnt] = tmp;
			gTx0Cnt++;			// ۽ Ʈ 
			CheckSum = CheckSum^tmp;
		}
	}
	CheckSum = CheckSum & 0x7f;

	gTx0Buf[gTx0Cnt]=CheckSum;
	gTx0Cnt++;			// ۽ Ʈ 
} 

//------------------------------------------------------------------------------
// 8bit  Position Move ϱ  Լ
// Input	: torq ID, Position
// Output	: None
//------------------------------------------------------------------------------
void PositionMove(BYTE torq, BYTE ID, BYTE position)
{
    BYTE CheckSum;
    ID = (BYTE)(torq << 5) | ID;
    CheckSum = (ID ^ position) & 0x7f;
    
    sciTx0Data(0xff);
	sciTx0Data(ID);
	sciTx0Data(position);
	sciTx0Data(CheckSum);
}                       

//------------------------------------------------------------------------------
// Ȯ  I/O Write ϱ  Լ
// Input	: ID, IOchannel
// Output	: None
//------------------------------------------------------------------------------
void IOwrite(BYTE ID, BYTE IOchannel)
{
    BYTE CheckSum; 
	ID=(BYTE)(7<<5)|ID; 
	CheckSum = (ID^100^IOchannel^IOchannel)&0x7f;

	gTx0Buf[gTx0Cnt]=HEADER;    gTx0Cnt++;			// ۽ Ʈ 
	gTx0Buf[gTx0Cnt]=ID;        gTx0Cnt++;			// ۽ Ʈ 
	gTx0Buf[gTx0Cnt]=100;       gTx0Cnt++;			// ۽ Ʈ 
	gTx0Buf[gTx0Cnt]=IOchannel;	gTx0Cnt++;			// ۽ Ʈ 
	gTx0Buf[gTx0Cnt]=IOchannel;	gTx0Cnt++;			// ۽ Ʈ 
	gTx0Buf[gTx0Cnt]=CheckSum; 	gTx0Cnt++;			// ۽ Ʈ    
	
	gTx0BufIdx++;
	sciTx0Data(gTx0Buf[gTx0BufIdx-1]);		// ùƮ ۽ 
	
}

//------------------------------------------------------------------------------
// ġ б (Position Send Command)  Լ
// Input	: ID, SpeedLevel, Position
// Output	: Current
// UART0 RX ͷƮ, Timer0 ͷƮ Ȱȭ Ǿ ־ 
//------------------------------------------------------------------------------
WORD PosRead(BYTE ID) 
{
	BYTE	Data1, Data2;
	BYTE	CheckSum, Load, Position; 
	WORD	startT;

	Data1 = (5<<5) | ID;
	Data2 = 0;
	gRx0Cnt = 0;			//  Ʈ  ʱȭ
	CheckSum = (Data1^Data2)&0x7f;
	sciTx0Data(HEADER);
	sciTx0Data(Data1);
	sciTx0Data(Data2);
	sciTx0Data(CheckSum);
	startT = gMSEC;
	while(gRx0Cnt<2){
        if(gMSEC<startT){ 	// и īƮ µ 
            if((1000 - startT + gMSEC)>RX_T_OUT)
            	return 444;	// ŸӾƿ  Ż
        }
		else if((gMSEC-startT)>RX_T_OUT) return 444;
	}
	return gRx0Buf[RX0_BUF_SIZE-1];
} 


//------------------------------------------------------------------------------
// Flash   б
//	MRIdx :   ε
//------------------------------------------------------------------------------
void GetMotionFromFlash(void)
{
	WORD i;

	for(i=0;i<MAX_wCK;i++){				// wCK Ķ ü ʱȭ
		Motion.wCK[i].Exist		= 0;
		Motion.wCK[i].RPgain	= 0;
		Motion.wCK[i].RDgain	= 0;
		Motion.wCK[i].RIgain	= 0;
		Motion.wCK[i].PortEn	= 0;
		Motion.wCK[i].InitPos	= 0;
	}
	for(i=0;i<Motion.NumOfwCK;i++){		//  wCK Ķ ҷ
		Motion.wCK[wCK_IDs[i]].Exist		= 1;
		Motion.wCK[wCK_IDs[i]].RPgain	= *(gpPg_Table+i);
		Motion.wCK[wCK_IDs[i]].RDgain	= *(gpDg_Table+i);
		Motion.wCK[wCK_IDs[i]].RIgain	= *(gpIg_Table+i);
		Motion.wCK[wCK_IDs[i]].PortEn	= 1;
		Motion.wCK[wCK_IDs[i]].InitPos	= MotionZeroPos[i];
	}
}


//------------------------------------------------------------------------------
// Runtime P,D,I ̵ ۽
// 		:  Runtime P,D,I̵ ҷͼ wCK 
//------------------------------------------------------------------------------
void SendTGain(void)
{
	WORD i;

	UCSR0B &= 0x7F;   		// UART0 RxͷƮ ̻
	UCSR0B |= 0x40;   		// UART0 TxͷƮ 

	while(gTx0Cnt);			//  Ŷ ۽   
	for(i=0;i<MAX_wCK;i++){					// Runtime P,D̵  Ŷ غ
		if(Motion.wCK[i].Exist)				// ϴ ID غ
			SendSetCmd(i, 11, Motion.wCK[i].RPgain, Motion.wCK[i].RDgain);
	}
	gTx0BufIdx++;
	sciTx0Data(gTx0Buf[gTx0BufIdx-1]);		// ùƮ ۽ 


	while(gTx0Cnt);			//  Ŷ ۽   
	for(i=0;i<MAX_wCK;i++){					// Runtime I̵  Ŷ غ
		if(Motion.wCK[i].Exist)				// ϴ ID غ
			SendSetCmd(i, 24, Motion.wCK[i].RIgain, Motion.wCK[i].RIgain);
	}
	gTx0BufIdx++;
	sciTx0Data(gTx0Buf[gTx0BufIdx-1]);		// ùƮ ۽ 
}


//------------------------------------------------------------------------------
// Ȯ Ʈ ۽
// 		:   Ȯ Ʈ ҷͼ wCK 
//------------------------------------------------------------------------------
void SendExPortD(void)
{
	WORD i;

	UCSR0B &= 0x7F;   		// UART0 RxͷƮ ̻
	UCSR0B |= 0x40;   		// UART0 TxͷƮ 

	while(gTx0Cnt);			//  Ŷ ۽   
	for(i=0;i<MAX_wCK;i++){					// Runtime P,D̵  Ŷ غ
		if(Scene.wCK[i].Exist)				// ϴ ID غ
			SendSetCmd(i, 100, Scene.wCK[i].ExPortD, Scene.wCK[i].ExPortD);
	}
	gTx0BufIdx++;
	sciTx0Data(gTx0Buf[gTx0BufIdx-1]);		// ùƮ ۽ 
}


//------------------------------------------------------------------------------
// Flash   б
//	ScIdx :  ε
//------------------------------------------------------------------------------
void GetSceneFromFlash(void)
{
	WORD i;
	
	Scene.NumOfFrame = gpFN_Table[gSIdx];	// Ӽ
	Scene.RTime = gpRT_Table[gSIdx];		//   ð[msec]
	for(i=0;i<Motion.NumOfwCK;i++){			//  wCK  ʱȭ
		Scene.wCK[i].Exist		= 0;
		Scene.wCK[i].SPos		= 0;
		Scene.wCK[i].DPos		= 0;
		Scene.wCK[i].Torq		= 0;
		Scene.wCK[i].ExPortD	= 0;
	}
	for(i=0;i<Motion.NumOfwCK;i++){			//  wCK  
		Scene.wCK[wCK_IDs[i]].Exist		= 1;
		Scene.wCK[wCK_IDs[i]].SPos		= gpPos_Table[Motion.NumOfwCK*gSIdx+i];
		Scene.wCK[wCK_IDs[i]].DPos		= gpPos_Table[Motion.NumOfwCK*(gSIdx+1)+i];
		Scene.wCK[wCK_IDs[i]].Torq		= gpT_Table[Motion.NumOfwCK*gSIdx+i];
		Scene.wCK[wCK_IDs[i]].ExPortD	= gpE_Table[Motion.NumOfwCK*gSIdx+i];
	}
	UCSR0B &= 0x7F;   		// UART0 RxͷƮ ̻
	UCSR0B |= 0x40;   		// UART0 TxͷƮ 

	delay_us(1300);
}


//------------------------------------------------------------------------------
//  ۽  
// 		:   ð Ӽ  interval Ѵ
//------------------------------------------------------------------------------
void CalcFrameInterval(void)
{
	float tmp;
	if((Scene.RTime / Scene.NumOfFrame)<20){
		return;
	}
	tmp = (float)Scene.RTime * 14.4;
	tmp = tmp  / (float)Scene.NumOfFrame;
	TxInterval = 65535 - (WORD)tmp - 43;

	RUN_LED1_ON;
	F_PLAYING=1;		//   ǥ
	TCCR1B=0x05;

	if(TxInterval<=65509)	
		TCNT1=TxInterval+26;
	else
		TCNT1=65535;

	TIFR |= 0x04;		// Ÿ̸ ͷƮ ÷ ʱȭ
	TIMSK |= 0x04;		// Timer1 Overflow Interrupt Ȱȭ(140)
}


//------------------------------------------------------------------------------
// Ӵ  ̵ 
//------------------------------------------------------------------------------
void CalcUnitMove(void)
{
	WORD i;

	for(i=0;i<MAX_wCK;i++){
		if(Scene.wCK[i].Exist){	// ϴ ID غ
			if(Scene.wCK[i].SPos!=Scene.wCK[i].DPos){
				// Ӵ    
				gUnitD[i] = (float)((int)Scene.wCK[i].DPos-(int)Scene.wCK[i].SPos);
				gUnitD[i] = (float)(gUnitD[i]/Scene.NumOfFrame);
				if(gUnitD[i]>253)	gUnitD[i]=254;
				else if(gUnitD[i]<-253)	gUnitD[i]=-254;
			}
			else
				gUnitD[i] = 0;
		}
	}
	gFrameIdx=0;				//  ε ʱȭ
}


//------------------------------------------------------------------------------
//   ۽ غ
//------------------------------------------------------------------------------
void MakeFrame(void)
{
	while(gTx0Cnt);			//   ۽   
	gFrameIdx++;			//  ε 
	SyncPosSend();			// ȭ ġ  ۽
}


//------------------------------------------------------------------------------
//   ۽
//------------------------------------------------------------------------------
void SendFrame(void)
{
	if(gTx0Cnt==0)	return;	//  Ͱ   
	gTx0BufIdx++;
	sciTx0Data(gTx0Buf[gTx0BufIdx-1]);		// ùƮ ۽ 
}


//------------------------------------------------------------------------------
// 
//------------------------------------------------------------------------------
void M_PlayFlash(void)
{
	float tmp;
	WORD i;

	GetMotionFromFlash();		//  wCK Ķ ҷ
	SendTGain();				// Runtime̵ ۽
	for(i=0;i<Motion.NumOfScene;i++){
		gSIdx = i;
		GetSceneFromFlash();	//   ҷ´
		SendExPortD();			// Ȯ Ʈ ۽
		CalcFrameInterval();	//  ۽  , Ÿ̸1 
		CalcUnitMove();			// Ӵ  ̵ 
		MakeFrame();			//   غ
		SendFrame();			//   ۽
		while(F_PLAYING);
	}
}


void SampleMotion1(void)	//   1
{
	gpT_Table			= M_EX1_Torque;
	gpE_Table			= M_EX1_Port;
	gpPg_Table 			= M_EX1_RuntimePGain;
	gpDg_Table 			= M_EX1_RuntimeDGain;
	gpIg_Table 			= M_EX1_RuntimeIGain;
	gpFN_Table			= M_EX1_Frames;
	gpRT_Table			= M_EX1_TrTime;
	gpPos_Table			= M_EX1_Position;
	Motion.NumOfScene 	= M_EX1_NUM_OF_SCENES;
	Motion.NumOfwCK 	= M_EX1_NUM_OF_WCKS;
	M_PlayFlash();
}
